<template>
    <div class="container vh-100 pt-5 mt-5" style="min-height: 560px;">
        <table class="table table-striped">
            <thead style="text-align: center">
                <tr>
                    <th scope="col">ID</th>
                    <th scope="col">Name</th>
                    <th scope="col">Email</th>
                    <th scope="col">User type</th>
                    <th scope="col">Option</th>
                </tr>
            </thead>
            <tbody>
                <tr v-for="user in users" :key="user.id">
                    <th scope="row" style="vertical-align: middle; text-align: center">{{ user.id }}</th>
                    <td style="vertical-align: middle">{{ user.name }}</td>
                    <td style="vertical-align: middle">{{ user.email }}</td>
                    <td style="vertical-align: middle">{{ user.user_type }}</td>
                    <td style="vertical-align: middle ; text-align: center">
                        <button v-if="user.user_type != 'admin'" @click="setAdmin(user.user_id)" class="btn btn-warning">Set
                            admin</button>
                        <button @click="deleteUser(user.user_id)" class="btn btn-danger">Delete</button>
                        <router-link :to="'/admin/transaksi/' + user.user_id" class="btn btn-primary">Transaksi</router-link>
                    </td>
                </tr>
            </tbody>
        </table>
    </div>
</template>

<script>
import axios from 'axios';

export default {
    data() {
        return {
            users: [] // Inisialisasi array users
        };
    },
    created() {
        // Panggil method fetchUsers saat komponen dibuat
        this.fetchUsers();
    },
    methods: {
        fetchUsers() {
            // Fetch data pengguna dari backend atau API menggunakan Axios
            axios.get('http://localhost:8000/api/user')
                .then(response => {
                    this.users = response.data; // Simpan data pengguna ke dalam array users
                })
                .catch(error => {
                    console.error('Error fetching users:', error); // Tampilkan pesan error jika gagal mengambil data
                });
        },
        setAdmin(userId) {
            // Mengirim permintaan untuk mengatur pengguna sebagai admin
            axios.post(`http://localhost:8000/api/set-admin/${userId}`)
                .then(response => {
                    console.log('User set as admin:', response.data);
                    // Jalankan ulang pengambilan data pengguna setelah berhasil mengatur sebagai admin
                    this.fetchUsers();
                })
                .catch(error => {
                    console.error('Error setting user as admin:', error);
                    // Tampilkan pesan error jika gagal mengatur sebagai admin
                    alert('Failed to set user as admin');
                });
        },
        deleteUser(userId) {
            // Mengirim permintaan untuk menghapus pengguna
            if (confirm('Are you sure you want to delete this user?')) {
                axios.delete(`http://localhost:8000/api/user/${userId}`)
                    .then(response => {
                        console.log('User deleted:', response.data);
                        // Jalankan ulang pengambilan data pengguna setelah berhasil menghapus pengguna
                        this.fetchUsers();
                    })
                    .catch(error => {
                        console.error('Error deleting user:', error);
                        // Tampilkan pesan error jika gagal menghapus pengguna
                        alert('Failed to delete user');
                    });
            }
        }
    }
};
</script>